	Ufiles Related Modules
	======================

These modules are available through the NTCC Webpage,
w3.pppl.gov/NTTC  under "Modules Library", as compressed
tarfiles, <name>.tar.gz, and as zip archives, <name>.zip.
Alternatively they can be obtained from ftp.pppl.gov
in pub/NTCC/.


****************
REVISION HISTORY
****************
      date         Description

  May 15, 1999  -- portability upgrade -- use portlib.a
                   MDS+ data access option via mdstransp module
                   Ufiles and TrGraf REAL*8 interface routines added.

  Oct 01, 2001  -- Use Makefiles instead of TRANSP generated scripts.

******************
    MODULES
******************

Note: Installation Notes for Uread, Ufiles, TrGraf and 
      PPPL_Utilities Modules are common in INSTALL, included in each
      "<module>.{tar.gz,zip}" archive. 
      Installation notes for Sglib and XtcTek are separate in 
      README_sglib and README_xtctek included in the modules. 
     

   MODULE
   ------      

   UREAD   	 --	Terminal control/interactive program automation.

   UFILES	 --	Standard for storing physics data.

   TRGRAF	 --	Interactive Data Display Library.

   PPL_UTILITIES --	Tools to study and analyze experimantal data.
			concat       -- Ufiles concatenator tool
			extrac       -- Ufiles extractor tool
			gaver{0,1,2} -- Ufile averaging utility
			gsmoo{0,1,2} -- smoothing/units conversion
			propane      -- generate Ufiles from hand entered
					 data for TRANSP input
			sawtoo	     -- Ufile sawtooth analyzer
			splice{2}    -- Ufiles splice utility
			thin{1,2}    -- Ufile thinning utility
			ugraf{1,2}   -- Ufiles display programs
			ulook0       -- scalar Ufile display program

   SGLIB	 --	Scientific Graphics Library.
			xplot        -- SGLIB output file plotting routine

   XtcTek	 --	Xtc	     -- X-windows Tektronix Controller.
			                (needs Motif)
			tek2ps	     -- convert tektronix to PS format.
		

Contents of Archives:
---------------------

All modules contain:

README:         This file.  Brief descriptions of the other files, and
                instructions for compiling, testing and installing the
                libraries and utilities.

INSTALL:	Detailed instructions how to build the libraries.

Makefile:       NOTE, "GNU make" must be used
                (usually in /usr/gnu/bin or /usr/local/bin).
                Main Makefile to envoke Makefile(s) in subdirectories.  


-- in subdirectory share:
   Make.flags:        Include file for Makefile, to setup Flags, etc.
   Make.local.sample: Include file for Makefile, to setup non-conventional,
                      site specific locations.

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing:

-- in subdirectory include/fpreproc:
   *.h files for source pre-processing.

-- the following subdirectories contain Makefile and sources to build
	 internally used libraries:

	- portlib       -- portability routines
	- sgdummy       -- stubs for sglib
	- vaxonly       -- miscellanious

-- in subdirectory test:
   demo input files for testing. 
 
The individual modules contain the following subdirectories with Makefile
and sources:

   Module      subdirectory	

   uread	ureadsub 	-- i/o command interface
  		 - nulltron	-- test program
		

   ufiles	uflib		-- Ufiles i/o subroutine library
		 - uftype	-- program
	   	mdspro 		-- IDL functions to read/write Ufiles 
	   	mdstransp	-- MDSplus interface       
		ufhdf	        -- netCDF/HDF interface
                ureadsub        -- i/o command interface

   trgraf	trgraf		-- display routines
		 - tgtest	-- test program for trgraf
		ureadsub	-- i/o command interface
		sglib		--  graphics library
	
   uutil	util		-- PPPL  utilities 
		test 		-- demo scripts for each utility
		concat_sub	-- for concat
		extrac_sub	-- for extrac
		rngsel_sub	-- old control routines for Ufiles
		sawcor_sub	-- for sawtoo
		thinsub		-- for thin*
		r4smlib		-- for smoothing
		smlib		-- for smoothing
	  	interp_sub	-- linear or bilinear interpolation
                ureadsub	-- i/o command interface
		uflib 		-- Ufiles i/o subroutine library
		ufhdf		-- netCDF/HDF interface
		mdstransp	-- MDSplus interface 
	        trgraf		-- display routines
		sglib		-- graphics library

		(a description of the demo scripts can be found
                 under the Ufiles help at

                     http://w3.pppl.gov/~pshare/help/ufiles.htm

                 see the section on utilities).

----------------------------------------------------------------------

   sglib	- README
		- Makefile         
		  sglib		-- graphics libraries (sg and jc)
		  - xplot	-- program to view a sglib plot file
		  - various test programs 

   xtctek   	- README
		- Makefile
		- sources for xtc
		- sources for tek2ps


Detailed information of each module is provided in 
http://w3.pppl.gov/NTCC/Ufiles


*************************
Installation Instructions
*************************
 
For Ufiles related modules see INSTALL provided with the archives.

For SGLIB (standalone) see ./sglib/README.
For XtcTek see ./xtctek/README.


IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:

        TRANSP Support - transp_support@pppl.gov

	Princeton Plasma Physics Laboratory

      subroutine mds_getfile(lun,node,fname,ier)
C Extract a text node from MDSplus and write into file
C
      implicit none
C Input
      integer        lun
      character*(*)  node      ! mds node name
      character*(*)  fname     ! file name (to be written)
C return
      integer        ier       !  0 = success
C                              ! -1 = Node does not exist
C                              !  1 = any other error
C MDSplus
      integer       Mds_Value, idescr_long, idescr_cstringarr
      integer       descr, mds__long
      integer       nid, ndsc
C Local
      integer, dimension(2) :: idims
      integer :: l,  ilz, retl
      integer :: nzlines  ! #of lines in text node
      character(120), dimension(:), allocatable :: ztext
      integer :: ialloc, iline
C
      integer        stat,  ios
      character*100  expr
C
      integer        ilnurd
C----------------------------------------------------------------
! Check if node exists
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      expr='getnci("'//node//'","NID_NUMBER")'
      l=ilnurd(expr)
      stat = Mds_Value(expr(1:l),ndsc,retl)
      if (mod(stat,2) .ne. 1) then
         if (stat .ne. 265388144) then     !  Node Not Found
            call mdsmsg(lun, 'MdsValue('//expr(1:l)//')', stat)
         endif
         ier = -1
         return
      endif
!
! Get size of text array
      expr = 'sizeof(' // node // ')' // char(0)
      l=ilnurd(expr)
      stat = Mds_Value(expr(1:l),idescr_long(nzlines),retl)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun, 'Mds_Value('//expr//')', stat)
         ier=1
         goto 9000
      else if(nzlines.le.0) then
         write(lun,*)
     &        ' ?mds_getfile: Mds_Value returned non-positive sizeof: ',
     &        nzlines
         ier=1
         goto 9000
      endif
      expr = 'size(' // node // ')' // char(0)
      l=ilnurd(expr)
      stat = Mds_Value(expr(1:l),idescr_long(nzlines),retl)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun, 'Mds_Value('//expr//')', stat)
         ier=1
         goto 9000
      else if(nzlines.le.0) then
         write(lun,*)
     &        ' ?mds_getfile: Mds_Value returned non-positive length: ',
     &        nzlines
         ier=1
         goto 9000
      else
! Allocate array
cxx      print *,'nzlines = ',nzlines
         if(allocated(ztext)) deallocate(ztext)
         allocate(ztext(nzlines), STAT=ialloc)
         if(ialloc  /=  0) then
            write(lun,*)
     >      '?mds_getfile: ERROR allocating ztext'
         endif
!
         idims(1)=nzlines
         idims(2)=0
! Read array
         stat = Mds_Value(node,
     &        idescr_cstringarr(ZTEXT,idims,1),retl)
         if (mod(stat,2).ne.1) then
            call mdsmsg(lun, 'Mds_Value('//node//')',
     &           stat)
            ier=1
            go to 9000
         else
cxx            print*,'write ',fname
! Write file
            open(7,STATUS='replace',iostat=ier,
     >           file=fname)
            if(ier.eq.0) then
               do iline=1,nzlines
                  ilz = len_trim(ztext(iline))
                  write(7,'(A)',iostat=ier) ztext(iline)(1:ilz)
               enddo
               if (ier .ne. 0) then
                  close(7,status='delete')
               else
                  close(7)
               endif
            else
               print*,'%mds_getfile: Error writing '//fname
               go to 9000
            endif
            CLOSE(7)	
         endif
      endif
      ier = 0
      return
C
 9000 continue
      return
      end

C******************** START FILE UFNTER.FOR ; GROUP UFNTER *************
C-----------------------------------------------------------
C  UFNTER
C
C  USER INTERFACE ROUTINE-- SET NAMING CONVENTIONS FOR FILENAME
C
C  ALSO SET FILE RESIDENT DEVICE AND PPN
c
C
      SUBROUTINE UFNTER(ILUN,ZNAM)
C
C  TbT Aug 23, 1993 -- Added R & T selections.
C  TBT Aug 1993 -- Change Zext from C*3 to  C*16
c
 
      USE UFILES
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
      CHARACTER*20 ZNAM
      CHARACTER*16 ZPRE
      CHARACTER*16 ZEXT
      Character*3  Zext3     ! tbt
      CHARACTER*16 ZDEV
      CHARACTER*64 ZFDIR,ZFDIRP,ZWORK
      CHARACTER*80 ZINP
      CHARACTER*4 ZTOK
      CHARACTER*16 ZSUB
      LOGICAL INIT,ISHOTN
C
C--------
C  mds+ stuff (dmc 16 Dec 1998)
C
      character*50 zserver
      character*20 ztree
      character*120 zpath
      character*20 znode
      integer imds
C
C--------
C
      DATA ISHOTN/.TRUE./
C
      DATA ZDEV/'                '/
      DATA ZEXT/'ZZZ'/
      DATA ZFDIR/'                                '/
      data zwork/' '/
C
      data zserver/'local'/
      data ztree/'default'/
      data zpath/' '/
      data znode/'(default)'/
C
      data imds/0/
C
C---------------------------------------------------------------
C  MOD DMC 15 JULY 1986
C  IF CHANNEL IS OLD, USE OLD NAME AS DEFAULT
C
      CALL UFINIT
C
      luntrm=lnout(0)
C
      ICHAN=IUXCHA(ILUN)
C
      IF(ICHAN.EQ.0) THEN
        CALL UFNPAD('Z',1,ZPRE,'UFNTER',IER)
        zext=' '          ! clear obsolete
      ELSE
        ZPRE=UPRFIX(ICHAN)
        ZEXT=UEXTND(ICHAN)
        ZDEV=UDEV(ICHAN)
        ZFDIR=UFDIR(ICHAN)
      ENDIF
C
      ILPRE=LEN(ZPRE)
      ILEXT=LEN(ZEXT)
        Ilext3=Len(Zext3)
      ILDEV=LEN(ZDEV)
      ILDIR=LEN(ZFDIR)
C
      iupper=LUFCAP
      iupsave=-1
C
C  INPUT ZNAM - 20 CHAR IDENTIFICATION OF FILE TYPE
C   E.G. "INPUT FILES         "
C  ILUN-- LOGICAL UNIT NUMBER TO ASSOCIATE FILE NAME SET WITH.
C
      INIT=.TRUE.
 10   CALL NEUPAG
 11   CONTINUE
C
C  MDS+ logic
C
      if(imds.eq.1) then
         call ufnter_mds(ilun,znam,
     1	imds,iquit,zserver,ztree,zpath,znode)
         if(iquit.eq.1) then
            go to 100
         else
            go to 10
         endif
      endif
C
      CALL UFSETR(ILUN,ZPRE,ZEXT,ZDEV,ZFDIR)
      if(iupper.eq.1) call ufupper(ilun)
      if(iupper.eq.0) call uflower(ilun)
      IF(.NOT.ISHOTN) CALL UFNSHO(ILUN)
      IF(LXOUT(0)) THEN
        WRITE(LUNTRM,1000)
 1000 FORMAT(/' <<UFNTER>> SET UFILES FILENAME FORM FOR:'/)
        CALL UFSNMD(LUNTRM,ZNAM,ILUN)
        WRITE(LUNTRM,1002)
      ENDIF
 1002 FORMAT(/' WHERE ###### IS THE VARIABLE SHOT NUMBER;'/
     >' IF DISK OR DIRECTORY NOT SPECIFIED, RMS DEFAULT IS USED'/
     >  ' OPTIONS:'/
     >  '  C - case (unix only) set filename to upper or lower case'/
     >  '  D - CHANGE DISK (DEVICE) NAME'/
     >  '  E - CHANGE DIRECTORY NAME'/
     >  '  F - CHANGE FILENAME 1 CHAR PREFIX AND .EXT SUFFIX'/
     >  '  G - GENERATE LONGER UFILES FILENAME PREFIX AND SUFFIX'/
     >  '  H - GENERATE LONGER UFILES FILENAME (PREFIX AND SUFFIX)',
     1         ' (Delimiters)'/
     >'  I - INCLUDE SHOT NUMBER ENCODED IN UFILES FILE NAME (default)'/
     >  '  J - ACCESS UFILE WITHOUT SHOT NUMBER ENCODED IN FILE NAME'/
     >  '  N - SPECIFY COMPLETE UFILE NAME - SAVE SHOT NUMBER'/
     >  '  M - *** MDS+ Signal Data Access ***'/
     >  '  P - CHANGE SINGLE CHARACTER FILENAME PREFIX'/
     >  '  R - CHANGE Multiple CHARACTER FILENAME PREFIX'/
     >  '  S - CHANGE FILENAME SUFFIX (3 Characters)'/
     >  '  T - CHANGE FILENAME SUFFIX (Delimiter required)'/
     >  '  Q - QUIT'/)
      CALL UREAD('UFNTER:  ENTER OPCODE (D/E/F/P/S/Q... ):$')
      if(lchar('M')) then
         imds=1-imds
         go to 10
      endif
      IOPT=IXUOPC('DEFPSQGIJNTRHC$')
      INIT=.TRUE.
      CALL UCHKOP(IOPT,0,1,100,-1,*11)
      INIT=.FALSE.
      GO TO (16,16,30,30,35,100,80,50,55,85,40,80,80,12) IOPT
C-----
C  select filename case (unix only)
C
 12   continue
        if(LXOUT(0)) write(LUNTRM,1012)
 1012 format(' Prepend "+" for change to default case; otherwise'/
     >         ' option applies to this Ufile only.'//
     >         ' enter "M" for mixed upper/lower case.  Note:  in'/
     >         ' main menu use "H" option to set prefix and suffix,'/
     >     ' and enclose the prefix and suffix strings in dbl quotes.'/)
      ideflt=0
      call uread(
     >'UFNTER:  enter U for uppercase, L for lowercase, or Q:$$')
      if(lchar('+')) ideflt=1
      if(lchar('U')) then
         iupper=1
         if(ideflt.eq.1) call ufncap(1)
         if(ideflt.eq.1) iupsave=-1
      else if(lchar('L')) then
         iupper=0
         if(ideflt.eq.1) call ufncap(0)
         if(ideflt.eq.1) iupsave=-1
      else if(lchar('M')) then
         if(ideflt.eq.0) iupsave=LUFCAP
         iupper=2
         call ufncap(2)
      else if(lchar('Q')) then
         go to 10
      else
         call uermsg('UFNTER:  enter U, L or Q',' ',0)
         go to 12
      endif
      go to 10
C-----
 16   CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1016)
 1016 FORMAT(
     >' options:'/
     >'  T -- select standard tokamak root path for data'/
     >'  S -- select standard tokamak subdirectory path for data'/
     >'  P -- give full explicit pathname'/
     >'  Q -- quit this menu without doing anything')
      CALL UREAD('UFNTER: choose pathname option:$')
      IF(LCHAR('Q')) THEN
        GO TO 10
      ELSE IF(LCHAR('P')) THEN
        GO TO 20
      ELSE IF(LCHAR('T')) THEN
        CALL UREADW('UFNTER: enter tokamak name:$',ZTOK)
        ZINP=' '
        CALL SGET_ENV('DATADIR',ZINP)
        INB=index(zinp,' ')-1
        ZINP(INB+1:)='/'//ZTOK
        GO TO 21
      ELSE IF(LCHAR('S')) THEN
        CALL UREADW('UFNTER: enter tokamak name:$',ZTOK)
        CALL UREADW('UFNTER: enter subdirectory name:$',ZSUB)
        ZINP=' '
        CALL SGET_ENV('DATADIR',ZINP)
        INB=index(zinp,' ')-1
        ILT=ILNURD(ZTOK)
        CALL ULOWER(ZSUB)
        ZINP(INB+1:)='/'//ZTOK(1:ILT)//'/'//ZSUB
        GO TO 21
      ELSE
        CALL UERMSG('%UFNTER:  invalid path option.',' ',0)
        GO TO 16
      ENDIF
C
 20   CONTINUE
      INIT=.TRUE.
      IF(LXOUT(0)) WRITE(LUNTRM,1091) ILDIR
C
 1091 format(
     >' enter a filename directory or path.  This path'/
     >' should lead up to but not include the filename itself.'/
     >' Relative pathnames are OK; lowercase and "/" OK.'/
     >' Maximum pathname length = ',i3,' including trailing "/".')
      call unixpath(zwork,zinp,iinp)
C
 21   CONTINUE
      IF(ZINP(1:2).EQ.'Q ') GO TO 10
      IF(ZINP(1:2).EQ.'q ') GO TO 10
      IF(ZINP(1:2).EQ.'0 ') GO TO 10
      IF((ZINP(1:2).EQ.'D ').OR.(ZINP(1:2).EQ.'d ')) THEN
        CALL UFNPAD(' ',1,ZFDIR,'UFNTER',IER)
        GO TO 10
      ENDIF
      ZFDIRP=ZFDIR
      if(zinp.ne.' ') then
         ilast=index(zinp,' ')-1
         if(zinp(ilast:ilast).ne.'/') then
            ilp1=ilast+1
            zinp(ilp1:ilp1)='/'
         endif
      endif
        IL=IUFTRM(ZINP,'UFNTER',IER)
        CALL UFNPAD(ZINP,IL,ZFDIR,'UFNTER DIRECTORY NAME',IER)
      IF(IER.NE.0) ZFDIR=ZFDIRP
      GO TO 10
C
 30   CONTINUE
      ZPRE=' '
      CALL UREADC(
     >   'UFNTER:  ENTER FILE PREFIX, A SINGLE LETTER:$$',ZPRE(1:1))
C
      IF(IOPT.EQ.4) GO TO 10
 35   CONTINUE
      CALL UREAD(
     >   'UFNTER: ENTER FILE .EXT EXTENSION (3 LETTER COMBO):$$')
      CALL URDBUF(ZEXT3,Ilen3,0)
      Zext = Zext3
      CALL UROTOR(3)
      GO TO 10
C
 40   CONTINUE     ! New version 8/93  tbt
      Call UReadW(
     >   'UFNTER: ENTER FILE .EXT EXTENSION (16 LETTER COMBO):$$',
     1   Zext)
 
      GO TO 10
C
 50   CONTINUE
      ISHOTN=.TRUE.
      GO TO 10
C
 55   CONTINUE
      ISHOTN=.FALSE.
      GO TO 10
C
C	                                                    Read PREfix
 80   CONTINUE
      IF(LXOUT(0) .and. Iopt .Eq. 7) WRITE(LUNTRM,1080) ILPRE,ILEXT3
      IF(LXOUT(0) .and. Iopt .Eq.13) WRITE(LUNTRM,1080) ILPRE,ILEXT
 1080 FORMAT(' MAX PREFIX LENGTH:  ',I2,' CHARACTERS'/
     >         ' MAX SUFFIX LENGTH:  ',I2,' CHARACTERS')
      CALL UREAD(
     >'UFNTER:  ENTER UFILES FILENAME PREFIX (MULTI-CHARACTER):$')
      CALL CDCOD(ZINP)
      ILAST=INDEX(ZINP,' ')-1
      IF(ILAST.LE.0) ILAST=LEN(ZINP)
      IF(ILAST.GT.ILPRE) THEN
        CALL UERMSG('% FILENAME PREFIX LENGTH ERROR:',ZINP,1)
        GO TO 10
      ENDIF
      ZPRE(1:ILPRE)=ZINP(1:ILPRE)
      If (Iopt .Eq. 12) Go to 10      ! Iopt=12 => R Only prefix.
C                                                    Go read suffix.
      If (Iopt .Eq.  7) GO TO 35      ! Iopt= 7 => G No delimiters
      If (Iopt .Eq. 13) Go to 40      ! Iopt=13 => H Delimiters
      If (Lxout(0)) Write (Luntrm,1093) Iopt ! Shouldn't get here   tbt
 1093   Format(//' Ufnter error at 1093 - bad Iopt =', I10/)
      Go to 10
C
 85   CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1080) ILPRE,ILEXT
      IF(LXOUT(0)) WRITE(LUNTRM,1082)
C
 1082 format(/' enter full filename spec, save encoded shot number'/)
      call unixfile('UFNTER',ZINP)
      IF(ZINP(1:2).EQ.'Q ') GO TO 10
      IF(ZINP(1:2).EQ.'q ') GO TO 10
C
C  DISK
C
      ilminp=len(zinp)
      irbrk=0
      do ic=ilminp,1,-1
        if(zinp(ic:ic).eq.'/') then
          if(irbrk.eq.0) irbrk=ic
        endif
      enddo
      if(irbrk.gt.ildir) then
        call uermsg('%UFNTER:  directory name too long',zinp,1)
        go to 85
      else if(irbrk.eq.0) then
        CALL UFNPAD(' ',1,ZFDIR,'UFNTER',IER)
        IST=1
      else
        CALL UFNPAD(' ',1,ZFDIR,'UFNTER',IER)
        ZFDIR(1:IRBRK)=ZINP(1:IRBRK)
        IST=IRBRK+1
      endif
C
C  PREFIX
      IBLANK=INDEX(ZINP(IST:),' ')+IST-1
      IF(IBLANK.LT.IST) IBLANK=LEN(ZINP)+1
C
      IDLMAX=IST-1
C
      ILDOT=INDEX(ZINP(IST:),'.')+IST-1
      IDLMAX=MAX0(IDLMAX,ILDOT)
      IF(ILDOT.LT.IST) ILDOT=LEN(ZINP)+1
C
      ILNUM=INDEX(ZINP(IST:),'#')+IST-1
      IDLMAX=MAX0(IDLMAX,ILNUM)
      IF(ILNUM.LT.IST) ILNUM=LEN(ZINP)+1
C
      IDLM=MIN0(IBLANK,ILDOT,ILNUM)
      IF(IDLM.LE.IST) THEN
        CALL UERMSG('%UFNTER: UFILE NAME PREFIX NOT FOUND',ZINP,1)
        GO TO 10
      ELSE IF((IDLM-IST).GT.ILPRE) THEN
        CALL UERMSG('%UFNTER: UFILE NAME PREFIX LENGTH ERROR',ZINP,1)
        GO TO 85
      ENDIF
      CALL UFNPAD(' ',1,ZPRE,'UFNTER',IER)
      ZPRE(1:IDLM-IST)=ZINP(IST:IDLM-1)
C
      IF(IDLM.EQ.IBLANK) GO TO 35
      IST=IDLMAX+1
C
C  SUFFIX
      IL=IBLANK-IST
      IF(IL.LE.0) GO TO 35
      IF(IL.GT.ILEXT) THEN
        CALL UERMSG('%UFNTER: UFILE NAME .EXT LENGTH ERROR',ZINP,1)
        GO TO 35
      ENDIF
      CALL UFNPAD(' ',1,ZEXT,'UFNTER',IER)
      ZEXT(1:IL)=ZINP(IST:IBLANK-1)
C
      GO TO 10
C
 100  CONTINUE
C
      if(iupsave.gt.0) LUFCAP=iupsave
C
      RETURN
      END
C-----------------------------------------------------------------------
      subroutine ufnter_mds(ilun,znam,
     1    imds,iquit,zserver,ztree,zpath,znode)
C
C  mds+ signal access options  -- give server, tree, path, ...
C
      integer ilun		! Ufiles lun / channel id
      character*(*) znam	! channel tag
C
      integer imds		! mds/Ufiles toggle
      integer iquit		! return "1" to quit
      character*(*) zserver	! MDS+ server
      character*(*) ztree	! MDS+ tree name
      character*(*) zpath	! MDS+ path
      character*(*) znode	! MDS+ node (appended to path)
C
      character*120 zfull	! full node path
C For ufiles from TRANSP runs
      character*7   ztok
      character*10  zrunid
C
C--------------------------------------
C  UREAD logical functions declarations...
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
C--------------------------------------
C
      iquit=0
C
      luntrm=lnout(0)
      ilz=max(1,len_trim(znam))
C
      zrunid=' '
      ztok=' '
 10   continue
      ils=max(1,len_trim(zserver))
      ilt=max(1,len_trim(ztree))
      ilp=max(1,len_trim(zpath))
      iln=max(1,len_trim(znode))
      ilr=max(1,len_trim(zrunid))
      ily=max(1,len_trim(ztok))
      if (ily .gt. 1) then      ! TRANSP run
         call ufsetr(ilun,'MDS+::'//zserver(1:ils),
     >        ztree(1:ilt)//'@'//ztok(1:ily)//'@'//zrunid(1:ilr),
     1        zpath(1:ilp),znode(1:iln))
      else if (ilr .gt. 1) then      ! BEAST run
         call ufsetr(ilun,'MDS+::'//zserver(1:ils),
     >        ztree(1:ilt)//'@'//zrunid(1:ilr),
     1        zpath(1:ilp),znode(1:iln))
      else
         call ufsetr(ilun,'MDS+::'//zserver(1:ils),ztree(1:ilt),
     1        zpath(1:ilp),znode(1:iln))
      endif
C
      call ufsnmd_nod0(zpath,znode,zfull,ilf)
C
      if(lxout(0)) then
         if (ilr .gt. 1) write (luntrm,1002) zrunid(1:ilr),ztok(1:ily)
 1002    format(/' TRANSP runid:       ',a,'  ',a)
         write(luntrm,1001) znam(1:ilz),zserver(1:ils),ztree(1:ilt),
     1	zpath(1:ilp),znode(1:iln),zfull(1:ilf)
 1001    format(/
     1' MDS+ signal input for:  ',a//
     2' ...MDS+ server:     ',a/
     3' ...MDS+ tree name:  ',a/
     4' ...MDS+ path:       ',a/
     5' ...MDS+ node:       ',a/
     6' ...full node path:  ',a//
     7' UFNTER_MDS Command options:'/
     8'  S -- set MDS+ server name'/
     9'  T -- set MDS+ tree name'/
     1'  P -- set MDS+ path'/
     2'  R -- revise "tail" of path'/
     3'  N -- set MDS+ node'/
     4'  U -- switch to Ufiles input mode'/
     5'  X -- extra specs for TRANSP runs'/
     6'  Q -- quit:  exit UFNTER using current MDS+ settings.'/)
      endif
C
      call uread('UFNTER_MDS:  enter option:$')
C
      if(lchar('Q')) then
         iquit=1
         return
C
      else if(lchar('U')) then
         imds=1-imds
         return
C
      else if(lchar('S')) then
         call ureadw(
     1	'UFNTER_MDS:  enter server name, "." for local:$',
     2	zserver)
         if(zserver.eq.'.') zserver='local'
C
      else if(lchar('T')) then
         call ureadw(
     1	'UFNTER_MDS:  enter tree name:$', ztree)
C
      else if(lchar('P')) then
         call ureadw(
     1	'UFNTER_MDS:  enter path, "." for blank path:$',
     2	zpath)
         if(zpath.eq.'.') zpath=' '
C
      else if(lchar('N')) then
         call ureadw(
     1	'UFNTER_MDS:  enter node name, "." for blank:$',
     2	znode)
         if(znode.eq.'.') znode=' '
C
      else if(lchar('R')) then
         if(ilp.le.1) then
            ibeg=1
         else
            do ic=ilp-1,1,-1
      	 if(zpath(ic:ic).eq.':') go to 20
      	 if(zpath(ic:ic).eq.'.') go to 20
            enddo
            ic=0
 20         continue
            ibeg=ic+1
         endif
         ilen=len(zpath)
         call ureadw(
     1	'UFNTER_MDS:  enter new tail of path:$',
     2	zpath(ibeg:ilen))
C
      else if(lchar('X')) then
         call ureadw(
     1	'UFNTER_MDS:  enter RUNID, "." for blank:$', zrunid)
         if (zrunid(1:1) .eq. '.') zrunid=' '
         call ureadw(
     1	'UFNTER_MDS:  enter TOK.YR, "." for blank:$', ztok)
         if (ztok(1:1) .eq. '.') ztok=' '
C
      else
         call uermsg('UFNTER_MDS:  invalid menu option',' ',0)
      endif
C
      go to 10
C
      end
C******************** END FILE UFNTER.FOR ; GROUP UFNTER ***************

      subroutine ufascio2(lun,f,nf1,nx,ny,code,iend,ierr)
C
C  ascii read or write of 2d dimensioned array
C    actually reads/writes by ufascio routine via buffer array
C
C    fortran format loop being avoided because of portability issues
C
C  arguments
C
      integer lun                 ! Fortran i/o channel
      real f(nf1,ny)              ! 2d data array
      integer nx,ny               ! dimensions of data to write in f
      character*1 code            ! 'W' to write, 'R' to read
      integer iend                ! set =1 if EOF encountered on read
      integer ierr                ! set =1 if error encountered on read
C
C---------------------------
C
C  buffer
C
      parameter (inbuf=600)  ! multiple of 6 (cf ufascio)
      common/uscrbufr/ ub(inbuf)
C
C---------------------------
C
      itot=nx*ny
C
      if(code.eq.'W') then
         ibuf=0
         idon=0
      else
C  read first buffer full
         ibuf=min(inbuf,itot)
         call ufascio(lun,ub,ibuf,code,iend,ierr)
         if(iend.gt.0) go to 1999
         if(ierr.gt.0) go to 1999
         idon=ibuf
         icur=1
      endif
C
C  data loop
C
      do iy=1,ny
         do ix=1,nx
            if(code.eq.'W') then
C  store in buffer
               ibuf=ibuf+1
               ub(ibuf)=f(ix,iy)
               if(ibuf.eq.inbuf) then
C  write full buffer
                  call ufascio(lun,ub,ibuf,code,iend,ierr)
                  idon=idon+ibuf
                  ibuf=0
               endif
            else
C  save from buffer
               f(ix,iy)=ub(icur)
               icur=icur+1
               if(icur.gt.ibuf) then
C  read a buffer full
                  ibuf=min(inbuf,(itot-idon))
                  if(ibuf.gt.0) then
                     call ufascio(lun,ub,ibuf,code,iend,ierr)
                     if(iend.gt.0) go to 1999
                     if(ierr.gt.0) go to 1999
                     idon=idon+ibuf
                     icur=1
                  endif
               endif
            endif   ! R/W
         enddo  ! ix
      enddo  ! iy
C
      if(ibuf.gt.0) then
         call ufascio(lun,ub,ibuf,code,iend,ierr)  ! write partial
      endif
C
 1999 continue
      return
      end

C******************** START FILE UFSCM2.FOR ; GROUP UFSCLK ******************
C---------------------------------------------------------------
C  UFSCM2
C   COMPARE KEYWORD LIST FROM SHOT 1 TO LIST FROM SHOT 2
C   SIMILAR TO ROUTINE UFSCMP BUT WITH DIFFERENT LABELING
C
      SUBROUTINE UFSCM2(ZLIST,ZVAL,IORD,NDIM,NUM,ISHOT,IDIFS)
C
      CHARACTER*10 ZLIST(3,NDIM,3)
      CHARACTER*6 ASHOT
      CHARACTER*40 ZLLAB(4)
      INTEGER IORD(NDIM,3),NUM(3),IDIFSA(4),ISHOT(2)
      REAL ZVAL(NDIM,3)
C
C  ZLIST-- SCALAR KEYWORDS AND LABELS
C  IORD-- CALCULATED ALPHABETIC ORDER ON LISTS
C  ZVAL-- REAL VALUES OF ENTRIES IN LIST
C   ROW 1: AVERAGED DATA LIST-- COMPILED FROM DATA AVERAGED SO FAR
C   ROW 2: NEW DATA LIST-- FROM DATA FILE JUST READ (NOT YET AVERAGED)
C   ROW 3: COMPARISON LIST  COMPUTED FROM ROWS 1 AND 2
C  NDIM-- ARRAY DIMENSION-- MAX NO. OF ENTRIES IN LIST
C  NUM(3)-- NUMBER OF ENTRIES IN EACH LIST
C
C  CALCULATE ALPHABETIC ORDERINGS
C
C *LISMAK* DATA SATEMENT MOVED 12-APR-88
C *LISMAK* DATA SATEMENT MOVED 12-APR-88
C *LISMAK* DATA SATEMENT MOVED 12-APR-88
C *LISMAK* DATA SATEMENT MOVED 12-APR-88
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,lxout
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C => UFSCM2               BEGIN DATA BLOCK
C => LISMAK 12-APR-88  MOVED DATA STATEMENTS
      DATA ZLLAB/'LIST1:  FROM FILE, SHOT ######          ',
     >             'LIST2:  FROM FILE, SHOT ######          ',
     >             'IN FILE OF SHOT ######, BUT NOT ######  ',
     >             'IN FILE OF SHOT ######, BUT NOT ######  '/
C => END DATA BLOCK
C ====================
C
      luntrm=lnout(0)
C
      WRITE   (ASHOT,1000) ISHOT(1)
 1000 FORMAT(I6)
      ZLLAB(1)(25:30)=ASHOT
      ZLLAB(3)(17:22)=ASHOT
      ZLLAB(4)(33:38)=ASHOT
      WRITE   (ASHOT,1000) ISHOT(2)
      ZLLAB(2)(25:30)=ASHOT
      ZLLAB(3)(33:38)=ASHOT
      ZLLAB(4)(17:22)=ASHOT
 5    CONTINUE
      DO 10 ILIS=1,2
      IF(NUM(ILIS).GT.0)
     >     CALL UFSCOR(NUM(ILIS),ZLIST(1,1,ILIS),IORD(1,ILIS))
 10   CONTINUE
C
 30   CONTINUE
C  COMPARE THE LISTS
      IDIFS=0
      DO 40 ITYP=1,4
      CALL UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,ITYP,1)
      IDIFS=MAX0(IDIFS,NUM(3))
      IDIFSA(ITYP)=NUM(3)
 40   CONTINUE
C
 100  CONTINUE
      CALL NEUPAG
      IF(LXOUT(0)) WRITE(LUNTRM,2001) ISHOT(1),ISHOT(2),NUM(1),NUM(2)
 2001 FORMAT(
     >  ' KEYWORD SCALAR LIST1:  FROM FILE, SHOT # ',I6/
     >  ' KEYWORD SCALAR LIST2:  FROM FILE, SHOT # ',I6/
     >  ' LIST1 HAS ',I3,' ENTRIES; LIST2 HAS ',I3,' ENTRIES')
      IF((LXOUT(0)).AND.(IDIFS.GT.0))
     >      WRITE(LUNTRM,2002) (IDIFSA(IJ),IJ=1,4)
 2002 FORMAT(
     >  1X,I3,' KEYWORD ENTRIES IN LIST1 ARE NOT IN LIST2'/
     >  1X,I3,' KEYWORD ENTRIES IN LIST2 ARE NOT IN LIST1'/
     >  1X,I3,' ENTRIES HAVE THE SAME KEYWORDS BUT DIFFERING LABELS'/
     >  1X,I3,' ENTRIES HAVE THE SAME KEYWORDS BUT DIFFERENT VALUES'/)
      IF((LXOUT(0)).AND.(IDIFS.EQ.0)) WRITE(LUNTRM,2003)
 2003 FORMAT(' >> LIST1 AND LIST2 ARE IDENTICAL'/)
      IF(LXOUT(0)) WRITE(LUNTRM,2005)
 2005 FORMAT(' >> OPTION CODES:'/
     >  '  1:  LIST ALL SCALARS IN LIST1'/
     >  '  2:  LIST ALL SCALARS IN LIST2')
      IF(LXOUT(0).AND.(IDIFSA(1).GT.0)) WRITE(LUNTRM,2051)
 2051 FORMAT(
     >  ' -1:  LIST ALL KEYWORD SCALARS IN LIST1 BUT NOT IN LIST2')
      IF(LXOUT(0).AND.(IDIFSA(2).GT.0)) WRITE(LUNTRM,2052)
 2052 FORMAT(
     >  ' -2:  LIST ALL KEYWORD SCALARS IN LIST2 BUT NOT IN LIST1')
      IF(LXOUT(0).AND.(IDIFSA(3).GT.0)) WRITE(LUNTRM,2053)
 2053 FORMAT('  3:  LIST ALL KEYWORDS FOR WHICH LABELS DISAGREE')
      IF(LXOUT(0).AND.(IDIFSA(4).GT.0)) WRITE(LUNTRM,2054)
 2054 FORMAT('  4:  LIST ALL KEYWORDS FOR WHICH VALUES DISAGREE')
      IF(LXOUT(0)) WRITE(LUNTRM,2055)
 2055 FORMAT('  Q:  ENTER "Q" TO EXIT'/)
      CALL UREAD('UFSCM2:  ENTER OPCODE (1/2////Q):$')
      IF(LCHAR('Q')) RETURN
      IANS=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 100
      IF(IANS.EQ.1) GO TO 110
      IF(IANS.EQ.2) GO TO 110
      IC1=0
      IC2=0
      IF((IANS.EQ.-1).AND.(IDIFSA(1).GT.0)) GO TO 200
      IF((IANS.EQ.-2).AND.(IDIFSA(2).GT.0)) GO TO 300
      IF((IANS.EQ.3).AND.(IDIFSA(3).GT.0)) GO TO 400
      IF((IANS.EQ.4).AND.(IDIFSA(4).GT.0)) GO TO 500
      GO TO 100
C------
 110  CONTINUE
      IF(NUM(IANS).EQ.0) GO TO 120
      CALL UFSCPR(ZLLAB(IANS),ZLIST(1,1,IANS),ZVAL(1,IANS),
     >     IORD(1,IANS),NUM(IANS),0)
      GO TO 100
 120  CONTINUE
      WRITE(LUNTRM,9051) IANS
 9051 FORMAT(/' % LIST',I1,' CONTAINS NO ENTRIES'/)
      CALL UPAUST(1)
      GO TO 100
C------
 200  CONTINUE
      CALL UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,1,1)
      CALL UFSCPR(ZLLAB(3),
     >     ZLIST(1,1,3),ZVAL(1,3),IORD(1,3),NUM(3),IC1)
      GO TO 100
C------
 300  CONTINUE
      CALL UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,2,1)
      CALL UFSCPR(ZLLAB(4),
     >     ZLIST(1,1,3),ZVAL(1,3),IORD(1,3),NUM(3),IC1)
      GO TO 100
C-----
 400  CONTINUE
C  PUT BOTH VERSIONS ON SAME PAGE IF NUMBER IS SMALL
      IF(IDIFSA(3).GT.10) GO TO 410
      IC1=-1
      IC2=1
 410  CONTINUE
      CALL UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,3,1)
      CALL UFSCPR(ZLLAB(1),
     >     ZLIST(1,1,3),ZVAL(1,3),IORD(1,3),NUM(3),IC1)
      CALL UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,3,2)
      CALL UFSCPR(ZLLAB(2),
     >     ZLIST(1,1,3),ZVAL(1,3),IORD(1,3),NUM(3),IC2)
      GO TO 100
C-----
 500  CONTINUE
C  PUT BOTH VERSIONS ON SAME PAGE IF NUMBER IS SMALL
      IF(IDIFSA(4).GT.10) GO TO 510
      IC1=-1
      IC2=1
 510  CONTINUE
      CALL UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,4,1)
      CALL UFSCPR(ZLLAB(1),
     >     ZLIST(1,1,3),ZVAL(1,3),IORD(1,3),NUM(3),IC1)
      CALL UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,4,2)
      CALL UFSCPR(ZLLAB(2),
     >     ZLIST(1,1,3),ZVAL(1,3),IORD(1,3),NUM(3),IC2)
      GO TO 100
C
      END
C******************** END FILE UFSCM2.FOR ; GROUP UFSCLK ******************

C******************** START FILE UCHUNS.FOR ; GROUP UFNTER *************
C--------------------------------------------------------------
C  UCHUNS
C  PERFORM UNITS TRANSFORMATION UNDER USER CONTROL
C
      SUBROUTINE UCHUNS(AID,UNITS,IFLAG,OLDUNS,ARR,NARR,
     >                    ZCONA,ZCONB,IX)
C
      REAL ARR(NARR)
      CHARACTER*10 UNITS,OLDUNS,zunits
      character*(*) AID
C
C  AID-- 1 LETTER ID OF VARIABLE TO UNDERGO UNITS TRANSFORM
C  UNITS-- 10 CHAR UNITS ARRAY FOR VARIABLE
C  IFLAG-- RETURNED =1 IF UNITS TRANSFORM PERFORMED, 0 O.W.
C           =2 IF *EXPONENTIAL* TRANSFORMATION IS PERFORMED
C  OLDUNS- OLD UNITS LABEL PUT HERE IF TRANSFORM PERFORMED
C  ARR(NARR)  ARRAY CONTAINING VARIABLE TO BE
C    TRANSFORMED (MULTIPLIED BY UNITS CONVERSION FACTOR)
C  ZCONA,ZCONB  (OUTPUT) CONVERSION FACTORS USED
C    X(NEW)=ZCONA*X(OLD)+ZCONB
C  IX: INPUT:  =1: ARRAY IS INDEPENDANT COORDINATE; DO NOT ALLOW
C      ORDER REVERSAL VIA ZCONA.LT.0.0
C              =2: DEPENDENT COORD, ZCONA.LT.0.0 IS ALLOWED
C
C  USER ENTERS CONVERSION FACTOR AND NEW UNITS LABEL
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,lxout
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      luntrm=lnout(0)
C
 5    CONTINUE
C
C  DEFAULT:
C
      ZCONA=1.0
      ZCONB=0.0
C
      CALL NEUPAG
      IFLAG=0
      OLDUNS=UNITS
 10   CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,2001) AID(1:1),OLDUNS
 2001 FORMAT(/' "',A1,'" ARRAY OLD UNITS:  "',A10,'"'//
     >  ' ENTER NEW UNITS TO TRANSFORM QUANTITY VIA'/
     >  ' X(NEW) = A*X(OLD) + B  **OR**  X(NEW)= B*|X(OLD)|**A;'/
     >  ' A AND B FACTORS SPECIFIED BELOW.'//
     >  ' enter "1" for blank units label'/)
      ZCON=1.0
      CALL UREAD(
     >'UCHUNS:  ENTER NEW UNITS (10 CHAR LABEL) OR "0" NOT TO CHANGE:$')
      call cdcod(zunits)
      if(zunits(1:2).eq.'Q ') return
      if(zunits(1:2).eq.'0 ') return
      if(zunits(1:2).eq.'1 ') zunits=' '
      units=zunits
      IFLAG=1
      CALL UCLEAR
      IF(LXOUT(0).AND.(IX.EQ.1)) WRITE(LUNTRM,2002)
 2002 FORMAT(' % POSITIVE CONVERSION FACTOR REQUIRED')
      IF(LXOUT(0)) WRITE(LUNTRM,2003)
 2003 FORMAT(
     >'   FOR EXPONENTIAL TRANSFORM SPECIFY "E" FOLLOWED BY NUMBER'/
     >'   %WARNING - EXPONENTIATION APPLIED TO ABS. VALUE OF DATA')
 11   CALL UREAD(
     >'UCHUNS:  ENTER CONVERSION FACTOR A: (NEW UNITS PER OLD UNIT)$')
      if(lchar('Q')) GO TO 5
      IF(LCHAR('E')) THEN
        IFLAG=2
        GO TO 11
      ENDIF
      ZCONA=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 100
      IF(ZCONA.EQ.0.0) GO TO 100
      IF((ZCONA.LT.0.0).AND.(IX.EQ.1)) GO TO 100
C
      CALL UREAD(
     >'UCHUNS:  ENTER OFFSET B (QUANTITY TO ADD OR FACTOR INTO DATA):$')
      if(lchar('Q')) GO TO 5
      ZCONB=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 100
      IF(IFLAG.EQ.2) THEN
C  IF B IS MULTIPLICATIVE...
        IF(ZCONB.EQ.0.0) GO TO 100
      ENDIF
C
      DO 20 I=1,NARR
       IF(IFLAG.EQ.1) THEN
        ARR(I)=ZCONA*ARR(I)+ZCONB
       ELSE
        ARR(I)=ZCONB*(ABS(ARR(I)))**ZCONA
       ENDIF
 20   CONTINUE
      RETURN
C
 100  CONTINUE
C
      UNITS=OLDUNS
      IFLAG=0
      CALL UERMSG('% ILLEGAL CONVERSION FACTOR',' ',0)
      GO TO 10
      	END
C******************** END FILE UCHUNS.FOR ; GROUP UFNTER ***************

      subroutine sget_env(varname,value)
C
C  get the value of an environment variable
C
C  14Mar2005   jim.conboy@jet.uk
C              if __IDL6_FIX, use cget_env ; w/around for name conflict between
C              IDL Vn 6 & Lahey/F90 getenv functions
C
#ifdef __NAGWARE
      use f90_unix_env
#endif
C
      implicit none
C
C  input:
      character*(*) varname             ! name to be translated
C  output:
      character*(*) value               ! translation returned
C
C  local:
#if __CRAY || __NAGWARE 
      integer length,ierr
#endif
#if __IBM || __RS6000 || __IDL6_FIX || __X1
      integer iret, cget_env
#endif
C
C  value=' ' on exit, if the environment variable (logical name) is
C  undefined.
C
      integer ilvar
C
      ilvar=max(1,len_trim(varname))
C
      value=' '
C
#if __IBM || __RS6000 || __IDL6_FIX || __X1
      iret = cget_env(varname(1:ilvar),value)
      if( iret.eq.0 ) value=' '
#elif __CRAY
      call pxfgetenv(varname(1:ilvar),0,value,length,ierr)
      if(ierr.ne.0) value=' '
#elif __NAGWARE
      call getenv(varname(1:ilvar),value,length,ierr)
      if(ierr.ne.0) value=' '
#elif __ABS
      call getenv_(varname(1:ilvar),value)
#else
      call getenv(varname(1:ilvar),value)
#endif
      call str_pad(value)
      return
      end

C******************** START FILE UFSCLK.FOR ; GROUP UFSCLK ******************
C-------------------------------------------------------------------
C  UFSCLK
C  LOOK AT SCALARS IN A UFILES FILE
      SUBROUTINE UFSCLK(ILUN,ISHOT,NSC,SCVAL,SCLAB,IORDER,IMOD,ILUNC)
C
      REAL SCVAL(NSC)
      INTEGER IORDER(NSC)
      CHARACTER*10 SCLAB(3,NSC),ZKEY
      CHARACTER*10 ZMODL(2)
      CHARACTER*40 ZFILE
C
C  SCVAL-- LIST OF SCALAR QUANTITY VALUES
C  IORDER-- WORK SPACE TO CALCULATE KEYWORD ALPHABETIC ORDER
C  SCLAB-- LIST OF KEYWORD/LABELS OF SCALARS
C    FIRST 10 CHARACTERS-- KEYWORD TERMINATED BY A ":"
C    SECOND 10 CHARACTERS-- DESCRIPTIVE LABEL
C    THIRD 10 CHARACTERS-- PHYSICAL UNITS OF QUANTITY
C
C  ILUN,ISHOT-- LUN, SHOT NO. NEEDED TO GEN UFILES FILENAME
C  PASS IMOD=1 TO ALLOW USER TO REVISE A SCALAR VALUE UNDER
C  "F" OPTION
C  IF IMOD=1 ILUNC CONTAINS SHOULD BE AN OPEN LUN TO WRITE OUT
C  REMARK THAT SCALAR HAS BEEN MODIFIED
C
C  USER OPTIONS:  LOOK AT ALL SCALARS, FETCH VALUE OF NAMED
C    SCALAR, QUIT
C
C  CALCULATE ALPHABETIC ORDER
C
C *LISMAK* DATA SATEMENT MOVED 12-APR-88
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,lxout
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C => UFSCLK               BEGIN DATA BLOCK
C => LISMAK 12-APR-88  MOVED DATA STATEMENTS
      DATA ZMODL/'          ','/MODIFY   '/
C => END DATA BLOCK
C ====================
C
      luntrm=lnout(0)
C
      CALL UFSCOR(NSC,SCLAB,IORDER)
      CALL UFSNAM(ISHOT,ZFILE,IER,ILUN)
      JMOD=1
      IF(IMOD.EQ.1) JMOD=2
C
C  MENU
C
 10   CONTINUE
      CALL NEUPAG
 11   IF(LXOUT(0)) WRITE(LUNTRM,2000) ZMODL(JMOD)
 2000 FORMAT(/' UFSCLK OPTIONS:'/
     >  ' D - DISPLAY - DISPLAY ALL SCALARS (ON PLOTTING DEVICE)'/
     >  ' F - FETCH   - FETCH',A10,'A SINGLE SCALAR'/
     >  ' Q - QUIT    - EXIT'/
     >  )
      CALL UREAD('UFSCLK:  ENTER OPCODE LETTER (D/F/Q):$')
      IANS=IXUOPC('DFQ$')
      CALL UCHKOP(IANS,0,1,100,-1,*11)
      GO TO (100,200,500) IANS
C  DISPLAY ALL SCALARS ON PLOT DEVICE
 100  CONTINUE
      CALL UFSCPR(ZFILE,SCLAB,SCVAL,IORDER,NSC,0)
      GO TO 10
 200  CONTINUE
C  FETCH A SINGLE SCALAR AND DISPLAY ON TERMINAL
      CALL UFGKEY(ZKEY)
C  SEARCH FOR MATCH IN LIST
      ISC=IUFKEY(ZKEY,SCLAB,NSC)
      IF(ISC.EQ.0) GO TO 290
C  DISPLAY FOUND VALUE
 220  CONTINUE
      WRITE(LUNTRM,2002) SCLAB(1,ISC),SCVAL(ISC),SCLAB(2,ISC),
     >     SCLAB(3,ISC)
 2002 FORMAT(/'  KEYWORD:  ',A10,'  ASSOCIATED VALUE:  ',1PE12.5/
     >          '    LABEL:  ',A10,'    PHYSICAL UNITS:  ',A10/)
      IF(JMOD.EQ.1) CALL UPAUST(1)
      IF(JMOD.EQ.1) GO TO 10
 280  CALL UREAD(
     >'UFSCLK:  ENTER NEW VALUE FOR THIS SCALAR OR "X" NOT TO CHANGE:$')
      IF(LCHAR('X')) GO TO 10
      IF(LCHAR('Q')) GOTO 10
      ZVAL=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 280
      ZVALP=SCVAL(ISC)
      SCVAL(ISC)=ZVAL
      WRITE(ILUNC,7000) SCLAB(1,ISC),ZVALP,ZVAL
 7000 FORMAT(1X,'*** SCALAR "',A10,'" VALUE CHANGED FROM ',1PE11.4,
     >  ' TO ',1PE11.4)
      WRITE(LUNTRM,7000) SCLAB(1,ISC),ZVALP,ZVAL
      CALL UPAUST(0)
      GO TO 10
 290  CONTINUE
      CALL UERMSG('% KEYWORD NOT IN FILE: ',ZKEY,2)
      GO TO 10
C---------
C  QUIT
 500  CONTINUE
      RETURN
      END
C******************** END FILE UFSCLK.FOR ; GROUP UFSCLK ******************

C******************** START FILE UFGKEY.FOR ; GROUP UFSCLK ******************
C---------------------------------------------------------------
C  UFGKEY
C  ALLOW USER TO NAME A KEYWORD
C
      SUBROUTINE UFGKEY(ZKEY)
C
      CHARACTER*10 ZKEY
C
      character*20 zcbuff
C
 10   CALL UREADW(
     >'UFGKEY:  ENTER SCALAR IDENTIFICATION KEYWORD (MAX 9 CHARS):$',
     >   zcbuff)
      ncharc=len_trim(zcbuff)

      IENDKY=INDEX(zCBUFF,':')
      IF(IENDKY.EQ.0) IENDKY=NCHARC+1
      IF((IENDKY.LE.10).AND.(IENDKY.GT.1))  GO TO 20
      CALL UERMSG('% KEYWORD TOO SHORT OR TOO LONG: ',ZCBUFF,0)
      GO TO 10
C  FORM KEYWORD
 20   CONTINUE
      ZKEY='          '
      ZKEY(1:IENDKY)=ZCBUFF(1:IENDKY)
      ZKEY(IENDKY:IENDKY)=':'
      CALL UCLEAR
      RETURN
      END
C******************** END FILE UFGKEY.FOR ; GROUP UFSCLK ******************

      program uftype
C
C History:
C 08/11/97 : CAL Add HDF and netCDF options
C
C  driver for a utility to open and read Ufile headers and provide a
C  summary output giving the type of Ufile
C
C  subsequent modifications -- can convert from one Ufile type to
C  another.
C
C----------------
C
      use UFILES
C
      character*256 zfile,ztfile,zfile2,zlfile
      character*32 zdev,zpre,zext,zext2
      character*128 zdir
C
      integer ishot
C
      integer info(8)
C
      logical lxout
C
C----------------
C
C  initialize
C
      call uinita(0)
C
      call ufinit
      call ufncap(2)
C
      lunold=88
      lunnew=89
C
      itemp=0
C
      icmpr=-1                          ! default -- report only
C
      iforce=0                          ! default on write:  only if format
C                                       ! changes
C
      if(lxout(0)) then
         write(6,1001)
 1001    format(/
     >' UFTYPE -- UFILES format analysis / conversion tool.'/
     >'  *to see the format of a UFILE just enter its filename; to get'/
     >'     lowercase letters inclose the name in dbl quotes.'/
     >'  *to see the format of a list of UFILES given in a list file,'/
     >'     enter .LIST followed by the list filename.'/
     >'  *enter .ASCII, .COMPRESS, .NETCDF or .HDF to request'/
     >'     conversion of file formats.'/
     >'  *enter .CONCAT followed by list filename and output filename'/
     >'     to join a sequence of Ufiles, given in the list, into a'/
     >'     single concatenated ascii file.'/
     >'  *enter .UNPACK followed by filename to unpack a file that was'/
     >'     created by a prior .CONCAT command.'/
     >'  *enter "Q" to quit.')
      endif
C
 10   continue
      call ureadw('uftype:  enter filename:$$',zfile)
      ilfile=index(zfile,' ')-1
C
      ilist=0                           ! =1 read filenames from a list file
      iconcat=0                         ! =1 and write to concatenated file
C
      if(zfile(1:10).eq.'.COMPRESS ') then
         icmpr=2                        ! write loss free compressed binary
         go to 10
      else if(zfile(1:5).eq.'.HDF ') then
         icmpr=3                        ! write HDF
         go to 10
      else if(zfile(1:8).eq.'.NETCDF ') then
         icmpr=4                        ! write NetCDF
         go to 10
      else if(zfile(1:8).eq.'.ASCII ') then
         icmpr=0                        ! write ASCII
         go to 10
      endif
C
      if(zfile(1:7).eq.'.FORCE ') then
         iforce=1                       ! force write even if no change
         go to 10
      endif
C
C  capture messages
C
      if(itemp.eq.0) then
         if(zfile(1:5).eq.'.TMP ') then
            call ureadw('uftype:  enter scratch filename:$$',ztfile)
            ilbl=index(ztfile,' ')-1
            open(unit=95,file=ztfile(1:ilbl),status='NEW')
            call ufemsg(-95)
            itemp=1
            go to 10
         else
            open(unit=95,status='SCRATCH')
            call ufemsg(-95)
            itemp=1
         endif
      endif
C
      if(zfile(1:2).eq.'Q ') then
         close(unit=95,status='DELETE')
         call uexita(0)
         stop
      endif
C
      if(zfile(1:6).eq.'.LIST ') then
         call ureadw('uftype:  enter list filename:$$',zlfile)
         ilunlist=96
         call ufopen(ilunlist,zlfile,1,ier,0)
         if(ier.ne.0) then
            call uermsg('?uftype:  list file open error',zlfile,0)
            go to 10
         endif
         ilist=1
      endif
C
      if(zfile(1:8).eq.'.CONCAT ') then
         call ureadw('uftype:  enter concat list filename:$$',zlfile)
         call ureadw('uftype:  enter concat output filename:$$',zfile2)
         call ufopen(lunnew,zfile2,2,ier,0)
         if(ier.ne.0) then
            call uermsg('?uftype:  output file open error',zfile2,0)
            go to 10
         endif
         ilunlist=96
         call ufopen(ilunlist,zlfile,1,ier,0)
         if(ier.ne.0) then
            call uermsg('?uftype:  list file open error',zlfile,0)
            close(unit=lunnew,status='delete')
            go to 10
         endif
         iconcat=1
         ilist=1
         iforce=1
         icmpr=0
      endif
c
      if(zfile(1:8).eq.'.UNPACK ') then
         call ureadw(
     >      'uftype:  enter input file (concatenated Ufiles):$',zfile2)
         call ufopen(lunold,zfile2,1,ier,0)
         if(ier.ne.0) then
            call uermsg('?uftype:  input file open error',zfile2,0)
            go to 10
         endif
         call ufunpk(lunold,lunnew)
         go to 10
      endif
C
 20   continue
      if(ilist.eq.1) then
         read(ilunlist,'(A)',end=90) zfile
         ilfile=index(zfile,' ')-1
      endif
C
      call ufnpars(zfile,zdev,zdir,zpre,ishot,zext,ier)
C
      if(ier.ne.0) then
         if(ilist.eq.0) then
            call uermsi('?uftype:  ufnpars error',ier,0)
         else
            call uermsg('?uftype:  ufnpars error on',zfile,0)
         endif
      else
C
         ilun=97
C
         iok=-1
         call ufsetr(ilun,zpre,zext,zdev,zdir)
         if(ishot.lt.0) call ufnsho(ilun)
         call ufoprd(ilun,max(0,ishot),ier)
         if(ier.ne.0) then
            write(6,'(1x,a,'':  open error'')') zfile(1:ilfile)
         else
            call uflchk(ilun,'uftype    ',ichan,ier)
            call ufhdck(ilun,info,ier)
            if(ier.ne.0) then
               write(6,'(1x,a,'':  read error'')') zfile(1:ilfile)
            else
               call uftype_report(zfile,ilfile,ufcprs(ichan),info,
     >            icmpr,iforce,iok)
            endif
         endif
         call ufclos(ilun)
C
         if(iok .ge. 0) then
            call uftype_convert(lunold,lunnew,info,zfile,zfile2,
     >         zdev,zdir,zpre,ishot,zext,zext2,iok,iconcat)
         endif
C
      endif
C
      if(ilist.eq.1) go to 20
      go to 10
C
 90   continue
      close(unit=ilunlist)
      go to 10
C
      end
C---------------------------------
C
      subroutine uftype_report(zfile,ilfile,kmprs,info,icmpr,iforce,iok)
C
      character*(*) zfile    ! filename
      integer ilfile         ! non-blank length of zfile
      integer kmprs          ! format code (0=ascii,...)
      integer info(8)        ! dimensioning data
C
      integer icmpr          ! flag that file conversion is desired
      integer iforce         ! flag that file compression is forced
      integer iok            ! output flag that conversion is needed
C
      character*256 zreport
C
      integer ilfmtstr(5)
C
      character*16 fmtstr(5)
C
      data fmtstr/'ascii           ',
     >            '16bit_binary    ',
     >            'portable_binary ',
     >            'HDF             ',
     >            'netCDF          '/
C
      data ilfmtstr/5,12,15,3,6/
C
      character*20 zbufc,zbuf2
C
C-----------------
C
      iok=-1
      if((icmpr.eq.2).and.((kmprs.ne.2).or.(iforce.eq.1))) then  ! compress
         iok=2
      else if((icmpr.eq.3).and.((kmprs.ne.3).or.(iforce.eq.1))) then  ! HDF
         iok=3
      else if((icmpr.eq.4).and.((kmprs.ne.4).or.(iforce.eq.1))) then  ! netCDF
         iok=4
      else if((icmpr.eq.0).and.((kmprs.ne.0).or.(iforce.eq.1))) then  ! ascii
         iok=0
      end if
C
      zbufc=' '
      write(zbufc,'(i1,''d'')') info(1)
C
      ikmprs=max(1,min(5,kmprs+1))
C
C  filename:  format  dimensionality
C
      zreport=zfile(1:ilfile)//':  '//
     >    fmtstr(ikmprs)(1:ilfmtstr(ikmprs))//' '//zbufc
C
      ilen=ilfile+9+ilfmtstr(ikmprs)
C
      zbufc=' '
      write(zbufc,'(i6)') info(8)
      do ic=1,6
         if(zbufc(ic:ic).ne.' ') go to 10
      enddo
      ic=6
 10   continue
C
      zbuf2='nsc='//zbufc(ic:6)
C
      ilb2=index(zbuf2,' ')-1
C
C  no. of scalars
C
      ilp1=ilen+1
      zreport(ilp1:)=zbuf2(1:ilb2)
      ilen=ilen+ilb2+2
C
C  dimensioning information
C
      if(info(1).gt.0) then
C
         write(zbufc,'(i8)') info(2)
         do ic=1,8
            if(zbufc(ic:ic).ne.' ') go to 20
         enddo
         ic=8
 20      continue
C
         zbuf2='npt='//zbufc(ic:8)
         ilb2=index(zbuf2,' ')-1
C
C  no. of data pts
C
         ilp1=ilen+1
         zreport(ilp1:)=zbuf2(1:ilb2)
         ilen=ilen+ilb2+2
C
         if(info(1).gt.1) then
            ilast=4+info(1)-2
            write(zbufc,'(i8)') info(3)
            do ic=1,8
               if(zbufc(ic:ic).ne.' ') go to 30
            enddo
            ic=8
 30         continue
C
            zbuf2=zbufc(ic:8)//' '
            ilb2=index(zbuf2,' ')-1
C
            do ii=4,ilast
               write(zbufc,'(i8)') info(ii)
               do ic=1,8
                  if(zbufc(ic:ic).ne.' ') go to 40
               enddo
               ic=8
 40            continue
               zbuf2(ilb2+1:)='x'//zbufc(ic:8)
               ilb2=index(zbuf2,' ')-1
            enddo
C
C  shape of data
C
            ilp1=ilen+1
            zreport(ilp1:)=zbuf2(1:ilb2)
            ilen=ilen+ilb2+1
         endif
C
      endif  ! dim .gt. 0
C
      if(iok .gt. -1) then
         ilp=ilen
         zreport(ilp+1:ilp+10)=' *rewrite*'
         ilen=ilen+10
      endif
C
      write(6,'(1x,a)') zreport(1:ilen)
C
      return
      end
C-----------------------------
      subroutine uftype_convert(lunold,lunnew,info,zfile,zfile2,
     >   zdev,zdir,zpre,ishot,zext,zext2,iopt,iconcat)
c
      integer info(8),ishot,iopt
c
      character*(*) zfile,zfile2
c
      character*(*) zdev,zdir,zpre,zext,zext2
c
c  convert a ufile to :
C            iopt = 2 :  portable compressed binary
C            iopt = 3 :  HDF
C            iopt = 4 :  netCDF
c
c  iconcat = 1:  writing into concatenated file, already open on lunnew
c
c  info  -- ufile dimensioning information
c  zfile -- orig filename
c  zfile2-- backup filename
c
c  zdev,zdir,zpre,ishot,zext -- ufile name components
c    "   "    "     "  ,zext2-- backup ufile name components
c
c  local buffers
c
      parameter(maxsc=1000)
      parameter(maxd=1000000)
c
      real sc(maxsc)
      character*30 sclab(maxsc)
c
      real datbuf(maxd)
      character*30 xlab,ylab,zlab,flab
c
      integer iproc
      character*10 shdate
      character*4 tokdev
c
c  local luns
c
      integer lunold,lunnew
c
c-------------------------------
c  check dimensioning limits
c
      ierd=0
      idim=info(1)
      insc=info(8)
      if(insc.gt.maxsc) then
         write(6,'('' uftype_convert:  scalar list too large'')')
         go to 999
      endif
c
      iu=0
      ierd=0
      if(idim.gt.0) then
         iaf=1
         iu=info(2)
         iax=iu+1
         iu=iu+info(3)
         inx=info(3)
         if(inx.le.0) ierd=1
         if(idim.gt.1) then
            iay=iu+1
            iu=iu+info(4)
            iny=info(4)
            if(iny.le.0) ierd=1
            if(idim.gt.2) then
               iaz=iu+1
               iu=iu+info(5)
               inz=info(5)
               if(inz.le.0) ierd=1
            endif
         endif
      else
         if(insc.le.0) ierd=1
      endif
c
      if(ierd.eq.1) then
         write(6,'('' uftype_convert:  unexpected zero dimension.'')')
         go to 999
      endif
c
      if(iu.gt.(maxd+1)) then
         write(6,'('' uftype_convert:  local data buffer too small'')')
         go to 999
      endif
c
      ilf=index(zfile,' ')
      if(ilf.le.0) ilf=len(zfile)
c
      zfile2=zfile
      zext2=zext
c
      zfile2(ilf:ilf)='~'
      call ufnpars(zfile2,zdev,zdir,zpre,ishot,zext2,ier)
      if(ier.ne.0) then
         write(6,'('' ... uftype_convert:  backup filename error.'')')
         go to 999
      endif
c
      ilf=index(zfile,' ')-1
      if(ilf.le.0) ilf=len(zfile)
c
      ilf2=index(zfile2,' ')-1
      if(ilf2.le.0) ilf2=len(zfile2)
c
c  rename old file (unix only)
c
      call frename(zfile(1:ilf),zfile2(1:ilf2),istat)
c
c  open and read old file
c
      call ufsetr(lunold,zpre,zext2,zdev,zdir)
      if(ishot.lt.0) call ufnsho(lunold)
      call ufoprd(lunold,max(0,ishot),ier)
      if(ier.ne.0) then
         write(6,'(1x,a,'':  read open error'')') zfile2(1:ilf2)
         go to 990
      endif
c
      if(idim.eq.0) then
         call uf0drd(lunold,tokdev,shdate,sc,sclab,max(1,insc),insc,ier)
         if (insc<=0) ier=1
      else if(idim.eq.1) then
         call uf1drd(lunold,tokdev,shdate,
     >      datbuf(iax),datbuf(iaf),inx,inx,iproc,xlab,flab,
     >      max(1,insc),insc,sc,sclab,ier)
      else if(idim.eq.2) then
         iflag=1
         call uf2drd(lunold,tokdev,shdate,
     >      datbuf(iaf),inx,datbuf(iax),inx,datbuf(iay),iny,iproc,
     >      inx,iny,iflag,flab,xlab,ylab,
     >      max(1,insc),insc,sc,sclab,ier)
      else if(idim.eq.3) then
         iflag=1
         call uf3drd(lunold,tokdev,shdate,
     >      datbuf(iaf),inx,iny,
     >      datbuf(iax),inx,datbuf(iay),iny,datbuf(iaz),inz,iproc,
     >      inx,iny,inz,iflag,flab,xlab,ylab,zlab,
     >      max(1,insc),insc,sc,sclab,ier)
      endif
      if(ier.ne.0) then
         write(6,'(1x,a,'':  read error'')') zfile2(1:ilf2)
         go to 990
      endif
c
c  open and write new file
c
      if(iconcat.eq.0) then
         call ufsetr(lunnew,zpre,zext,zdev,zdir)
         if(ishot.lt.0) call ufnsho(lunnew)
         call ufcmpr(lunnew,iopt)       ! loss free compressed portable binary
         call ufopwr(lunnew,max(0,ishot),ier)
      else
         call ufcchd(lunnew,zpre,zext,zdev,zdir,ishot,ier)
      endif
      if(ier.ne.0) then
         write(6,'(1x,a,'':  write open error'')') zfile2(1:ilf2)
         go to 980
      endif
c
      if(idim.eq.0) then
         call uf0dwr(lunnew,tokdev,shdate,sc,sclab,insc,ier)
      else if(idim.eq.1) then
         call uf1dwr(lunnew,tokdev,shdate,
     >      datbuf(iax),datbuf(iaf),inx,iproc,xlab,flab,
     >      insc,sc,sclab,ier)
      else if(idim.eq.2) then
         iflag=1
         call uf2dwr(lunnew,tokdev,shdate,
     >      datbuf(iaf),inx,datbuf(iax),inx,datbuf(iay),iny,iproc,
     >      flab,xlab,ylab,
     >      insc,sc,sclab,ier)
      else if(idim.eq.3) then
         iflag=1
         call uf3dwr(lunnew,tokdev,shdate,
     >      datbuf(iaf),inx,iny,
     >      datbuf(iax),inx,datbuf(iay),iny,datbuf(iaz),inz,iproc,
     >      flab,xlab,ylab,zlab,
     >      insc,sc,sclab,ier)
      endif
      if(ier.ne.0) then
         write(6,'(1x,a,'':  write error'')') zfile2(1:ilf2)
         go to 990
      endif
c
c  spool the comments
c
      call uspool(lunold,lunnew)
c
c  close and exit
c
      if(iconcat.eq.0) call ufclos(lunnew)
      call ufclos(lunold)
c     delete or restore the old file:
      if(iconcat.eq.0) then
         call fdelete(zfile2(1:ilf2),istat)
      else
         call frename(zfile2(1:ilf2),zfile(1:ilf),istat)
      endif
c
      return
c
c  close output file after error
c
 980  continue
      call ufclos(lunnew)
      close(unit=lunnew,err=981)
 981  continue
c
 990  continue
c
c  close input file after error
c  rename back (unix only)
c
      call ufclos(lunold)
      close(unit=lunold,err=991)
 991  continue
c
      call frename(zfile2(1:ilf2),zfile(1:ilf),istat)
c
 999  continue
      write(6,'('' ...uftype_convert:  conversion failed.'')')
c
 1000 continue
      return
      end
c-------------------------------------
      subroutine ufunpk(lunold,lunnew)
c
c  read concatenated ascii ufile, unpack into separate Ufiles.
c  this is done by copying ascii lines, not by Ufiles library software.
c
      character*140 zline               ! input buffer
      character*120 zfile
c
      character*16 zpre,zext,zdev
      character*80 zdir
c
c--------------------------
c
      ilen=len(zline)
      iopen=0
c
 10   continue
      call ufunpk_next(lunold,zpre,zext,zdev,zdir,ishot,ieof)
      if(ieof.eq.1) go to 90
c
c  new filename info found
c
 20   continue
      if(iopen.eq.1) then
         close(unit=lunnew)
         iopen=0
      endif
c
c  form filename
c
      zfile=' '
      ilpre=max(1,(index(zpre,' ')-1))
      ilext=max(1,(index(zext,' ')-1))
      if((ishot.lt.0).or.(ishot.gt.999999)) then
         zfile=zpre(1:ilpre)//'.'//zext(1:ilext)
      else if(ishot.le.99999) then
         write(zfile,'(a,i5.5,''.'',a)') zpre(1:ilpre),
     >      ishot,zext(1:ilext)
      else
         write(zfile,'(a,i6,''.'',a)') zpre(1:ilpre),
     >      ishot,zext(1:ilext)
      endif
c
c  open file
c
      ilfile=index(zfile,' ')-1
      call ufopen(lunnew,zfile,2,ier,0)
      if(ier.ne.0) then
         write(6,'('' uftype:  output open failure:  '',a)')
     >      zfile(1:ilfile)
         go to 10                       ! look for another filename
      else
         iopen=1
         write(6,'('' uftype:  unpacking Ufile:  '',a)') zfile(1:ilfile)
      endif
c
c  open OK, now copy data
c
 30   continue
      read(lunold,'(A)',end=90) zline
c
c  check for new filename, start of new file
c
      if(zline(1:10).eq.'>>ufcchd: ') then
         call ufunpk_pars(zline,zpre,zext,zdev,zdir,ishot,ier)
         if(ier.eq.0) then
            go to 20                    ! new filename
         else
            go to 10                    ! look for new filename
         endif
      endif
c
c  normal line, get length
c
      do ic=ilen,1,-1
         if(zline(ic:ic).ne.' ') go to 40
      enddo
      ic=1
 40   continue
      iline=ic
c
      write(lunnew,'(A)') zline(1:iline)
c
      go to 30
c--------------------------
 90   continue
      if(iopen.eq.1) close(unit=lunnew)
      close(unit=lunold)
      return
      end
c------------------------------------------------------------------
c  look for special line containing filename info
c
      subroutine ufunpk_next(lunold,zpre,zext,zdev,zdir,ishot,ieof)
c
      integer lunold                    ! input lun
      character*(*) zpre,zext,zdev,zdir ! filename parts (output)
      integer ishot                     ! shot number (output)
      integer ieof                      ! eof flag (output, 1=EOF)
c
      character*140 zline
c
c-------------------------------------
c
      ieof=0
 10   continue
      read(lunold,'(A)',end=90) zline
      if(zline(1:10).eq.'>>ufcchd: ') then
         call ufunpk_pars(zline,zpre,zext,zdev,zdir,ishot,ier)
         if(ier.eq.0) then
            go to 20                    ! new filename found
         else
            go to 10                    ! look for new filename
         endif
      else
         go to 10                       ! keep looking for new filename
      endif
c
 20   continue
      return
c
c EOF exit
c
 90   continue
      ieof=1
      return
c
      end
c------------------------------------------------------------------
c  parse line containing filename info
c
      subroutine ufunpk_pars(zline,zpre,zext,zdev,zdir,ishot,ier)
c
      character*(*) zpre,zext,zdev,zdir ! filename parts (output)
      integer ishot                     ! shot number (output)
      integer ier                       ! error flag (output, 0=no error)
c
      character*140 zline               ! input line
      character*1 zcomma,zblank
c
c-------------------------------------
c
      ier=0
c
      zpre=' '
      zext=' '
      zdev=' '
      zdir=' '
      ishot=-99
c
      if(zline(1:10).ne.'>>ufcchd: ') then
         write(6,*) 'ufunpk call error, zline=',zline
         ier=1
         return
      endif
c
      zcomma=','
      zblank=' '
c
      call ufgfld(zline,'pre=',zcomma,i1,i2,ier)
      if(ier.ne.0) return
      zpre=zline(i1:i2)
c
      call ufgfld(zline,'shot=',zcomma,i1,i2,ier)
      if(ier.ne.0) return
      read(zline(i1:i2),'(i6)') ishot
c
      call ufgfld(zline,'ext=',zcomma,i1,i2,ier)
      if(ier.ne.0) return
      zext=zline(i1:i2)
c
      call ufgfld(zline,'dev=',zcomma,i1,i2,ier)
      if(ier.ne.0) return
      zdev=zline(i1:i2)
c
      call ufgfld(zline,'dir=',zblank,i1,i2,ier)
      if(ier.ne.0) return
      zdir=zline(i1:i2)
c
      return
      end
c---------------------------------
      subroutine ufgfld(zline,zkey,zdelim,i1,i2,ier)
c
c  find value matching specified key in input line
c  return limits of value field; value field terminated by
c  passed delimiter character
c
c  input:
c   zline -- input line to be scanned for a field
c   zkey  -- substring identifying start of field
c            should be terminated with = and have no trailing blanks
c   zdelim-- character that terminates field
c
      character*(*) zline,zkey,zdelim
c
c  output:
c   i1 -- character index, start of field
c   i2 -- character index, end of field
c   ier -- completion code, 0 = normal
c
      integer i1,i2,ier
c
c  for example, if on input:
c    zline=' xyz abc fielda=TEST, fieldb=TEST2
c     zkey='fielda='
c   zdelim=','
c
c  then on output we get ier=0, i1=17, and i2=20
c  with zline(i1:i2)='TEST'.
c
c  ier is the completion code, 0 indicates normal.
c
c---------
c
      ier=0
      i1=0
      i2=0
c
      ilkey=len(zkey)
      ikey=index(zline,zkey)
      if(ikey.eq.0) then
         write(6,1001) zkey,zline
 1001    format(' %ufgfld(uftype.for):  key "',a,'" not foud in line:'/
     >      1x,a)
         ier=1
         return
      endif
c
      ilen=len(zline)
c
      i1=min(ilen,(ikey+ilkey))
      do ic=i1+1,ilen
         if(zline(ic:ic).eq.zdelim(1:1)) go to 20
      enddo
      ic=ilen+1
 20   continue
      i2=ic-1
c
      return
      end
 

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_add_tag(node,tag)
      implicit none
      character*(*) node, tag
      mds_add_tag = 0
      return
      end
#else
c-----------------------------------------------------------------------
c mds_add_tag
c add mdsplus tag
c
c input
c   node   -- character
c   tag   -- character
c returns
c   1          -- on success
c   odd number -- on error
c
c-----------------------------------------------------------------------
      integer function mds_add_tag(node, tag)
      implicit none
      character*(*) node, tag
 
      integer     status, cmd_status, cmd_stat2
      integer     dsc_cmd_status, dsc_cmd_stat2
      integer     retlen
 
      integer istat, icmdstat
      character*4097 strarg
 
      integer mds__leniftrim
      integer descr, MdsValue, mds__long, mds__cstring
      integer mdsdclfdo
      integer ndsc, cdsc, nid, lt
      character*1    bcks
 
      bcks=char(92)                 ! x5c = '\'
 
      status = 0
 
C Check if tag already exists
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      lt=max(1, mds__leniftrim(tag))+1
      call mds__copywnull(strarg, bcks//tag)
      cdsc = descr(mds__cstring(), strarg, 0, lt)
      status = MdsValue("getnci($,'NID_NUMBER')",cdsc,ndsc,0,retlen)
C      print*,"getnci",status,nid,retlen
 
      if (mod(status,2) .eq. 1) then
         mds_add_tag=1
         return
      endif
 
      dsc_cmd_status = descr(mds__long(), cmd_status, 0)
C Check if open for edit
      strarg = 'GETDBI("OPEN_FOR_EDIT")' // CHAR(0)
      status = MdsValue(strarg, dsc_cmd_status, 0, retlen)
      istat    = mod(status, 2)
      icmdstat = mod(cmd_status, 2)
 
      if (istat.eq.1) then
C If failure, open for edit:
         if (cmd_status.ne.1) then
             dsc_cmd_stat2 = descr(mds__long(), cmd_stat2, 0)
C           strarg = 'tcl("edit $EXPT/shot=$SHOT")'//CHAR(0)
            print *,
     >      ' ?mds_add_tag - Error: tree not open for edit'
            status = MdsValue(strarg, dsc_cmd_stat2, 0, retlen)
            istat    = mod(status, 2)
            icmdstat = mod(cmd_stat2, 2)
         endif
         if ((istat.eq.1) .and. (icmdstat.eq.1)) then
               strarg = 'tcl("add tag ' //node // ' ' //
     >                  tag // ' ")' //CHAR(0)
C     print *,strarg(1:80)
            status = MdsValue(strarg, dsc_cmd_status, 0, retlen)
            istat    = mod(status, 2)
            icmdstat = mod(cmd_status, 2)
            if (istat.eq.1) then
               status = cmd_status
            endif
         endif
      endif
      go to 100
 
 100  continue
 
      mds_add_tag = status
 
      return
      end
 
#endif

C******************** START FILE UFACOM.FOR ; GROUP UFNTER ******************
C-------------------------------------------------------------------
C  UFACOM
C  ALLOW USER TO APPEND COMMENTS TO OUTPUT FILE
C
      SUBROUTINE UFACOM(ILUN)
      implicit NONE
C
      integer, intent(in) :: ilun   !  LUN for comments file
C
      integer :: luntrm,lnout,ncharc
      logical :: lxout
C
      character*132 zcbuff
C-------------------------------------------------------------------
C
      luntrm=lnout(0)
      zcbuff=' '
C
      WRITE(ILUN,4005)
 4005 FORMAT(/' USER COMMENTS:')
C
      CALL UCLEAR
      CALL CHXOUT
      IF(LXOUT(0)) WRITE(LUNTRM,2001)
 2001 format(' % UREAD typeahead turned off.  Lower case indented'/
     >'   comments may be typed.  To exit, type "x" or "X" in the'/
     >'   FIRST character position followed by a carriage return')
      CALL UREADLL(
     >'UFACOM:  ENTER COMMENTS FOR OUTPUT FILE (max 80 CHARS/LINE):$',
     >   zcbuff)

 160  CONTINUE
      ncharc=len_trim(zcbuff)

      IF(NCHARC.EQ.1) THEN
        IF((ZCBUFF(1:1).EQ.'X').OR.(ZCBUFF(1:1).EQ.'x')) GO TO 180
      ELSE IF(NCHARC.EQ.2) THEN
C  FOR COMPATIBILITY WITH OLD INDIRECT INPUT FILES...
        IF((ZCBUFF(1:2).EQ.' X').OR.(ZCBUFF(1:2).EQ.' x')) GO TO 180
      ENDIF
      WRITE(ILUN,4006) zcbuff(1:max(1,ncharc))
 4006 FORMAT(1X,A)
c
c  read next input line
c
      CALL UREADLL('$',zcbuff)
      GO TO 160
C
 180  CONTINUE
C  RE-ENABLE TYPEAHEAD WITH EMPTY BUFFER
      CALL UCLEAR
      CALL CHXOUT
C
      RETURN
      END
C******************** END FILE UFACOM.FOR ; GROUP UFNTER ******************
